package esi.ew.report.RP001;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import com.plw.util.Converter;

import esi.ew.common.TYPE_DATA_STATUS;
import esi.ew.report.common.JDBCUtil;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_DISABLE_STATUS;
import esi.examwh.model.common.TYPE_EXAM;

public class RP001Generator {
	
	private String ls_className = "RP001Generator";
    private JDBCUtil DBConn;
	private List<RP001Result> io_RPRL;

    public RP001Generator() throws ClassNotFoundException, SQLException {
		DBConn = new JDBCUtil();
	}
    
    public Integer GetNOfExamItemByObjectiveID(Integer ai_objectiveID) throws SQLException{
    	String methodName = "GetNOfExamItemByObjectiveID";
		Integer li_examItemNo = 0;
		if(ai_objectiveID < 0){
			return 0;
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("ISNULL(COUNT(EI.ExamItemID),0) examItemNo ");
		sb_SQLCommand.append("FROM ExamItem EI ");
		sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_objectiveID != null){
			sb_SQLCommand.append("AND EI.EI_ObjectiveID  = " + ai_objectiveID + " ");
		}
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "--> Query : " + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			
			li_examItemNo = lo_Result.getInt("examItemNo");
		}
		
		return li_examItemNo;
	}
    
    public String GetBehaviorDefinitionByBehaviorID(Integer ai_BehaviorID) throws SQLException{
    	String methodName = "GetBehaviorDefinitionByBehaviorID";
		String ls_behaviorDefinition = "";
		if(ai_BehaviorID <= 0){
			return "xxx";
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT  ");
		sb_SQLCommand.append("ISNULL(BL.BL_Name,'') behaviorDefinition ");
		sb_SQLCommand.append("FROM BehaviorLevel BL ");	
		sb_SQLCommand.append("WHERE BL.BL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_BehaviorID != null){
			sb_SQLCommand.append("AND BL.BehaviorLevelID  = " + ai_BehaviorID + " ");
		}
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query :" + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			ls_behaviorDefinition = lo_Result.getString("behaviorDefinition");
		}
		
		return ls_behaviorDefinition;
	}
    
//	จำนวนข้อสอบในชุดวิชา
	public Integer GetTotalExamItemBySubjectID(Integer ai_subjectID) throws SQLException{
		String methodName = "GetTotalExamItemBySubjectID";
		Integer li_examItemNo = 0;
		if(ai_subjectID < 0){
			return 0;
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("ISNULL(COUNT(EI.ExamItemID),-1) totalExamItemNo ");
		sb_SQLCommand.append("FROM ExamItem EI ");
		sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		
		// Samaporn @20240123
		sb_SQLCommand.append("AND EI.EI_DisableStatus IN (");
//		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_DISABLE.getValue());
//		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_ENABLE.getValue());
		sb_SQLCommand.append(") ");
		
		// Samaporn @20190827
		sb_SQLCommand.append("AND EI.EI_ExamType  = ( " );
		sb_SQLCommand.append(TYPE_EXAM.TYPE_OBJECTIVE.getValue());
		sb_SQLCommand.append(") ");
		
		if(ai_subjectID != null){
			sb_SQLCommand.append("AND EI.EI_SubjectID  = " + ai_subjectID + " ");
		}
//		sb_SQLCommand.append("AND EI.EI_BehaviorLevelID IS NOT NULL ");
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query :" + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			
			li_examItemNo = lo_Result.getInt("totalExamItemNo");
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "totalExamItemNo :" + li_examItemNo);
		return li_examItemNo;
	}
	
	// Samaporn @20191008 
	public String GenSQLFindAllObjectiveInSection(List<Integer> ao_subjectID) {
		String methodName = "GenSQLFindAllObjectiveInSection";
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT  OBJSubject.* ");
		sb_SQLCommand.append("FROM ");
		sb_SQLCommand.append("( ");
			sb_SQLCommand.append("SELECT ");
			sb_SQLCommand.append("SJ.SubjectID subjectID, ST.SectionID sectionID,OJ.ObjectiveID objectiveID ,UN.UnitID unitID, ");
			sb_SQLCommand.append("ISNULL(OJ.OJ_Name,'') objective,ISNULL(OJ.OJ_Order,-1) orderOfObjectiveInSection,ISNULL(ST.ST_Order,-1) section,  ");
			sb_SQLCommand.append("ISNULL(UN.UN_Order,-1) unit,ISNULL(SJ.SJ_Code,'') subjectCode,ISNULL(SJ.SJ_SubjectPrintedName,'') subjectName, ISNULL(EI.EI_BehaviorLevelID,-1) behaviorLevelID,  ");//behaviorLevelID,ISNULL(BL.BL_Name,'') behaviorDefinition ");
			sb_SQLCommand.append("ROW_NUMBER() OVER(PARTITION BY OJ.ObjectiveID ORDER BY OJ.ObjectiveID ASC) AS ObjectiveRow#,  ");
			sb_SQLCommand.append("ROW_NUMBER() OVER(PARTITION BY OJ.ObjectiveID,EI.EI_BehaviorLevelID ORDER BY OJ.ObjectiveID,EI.EI_BehaviorLevelID ASC) AS BehaviorLeveRow#,  ");
				// Find ExamItem
				sb_SQLCommand.append("(");
				sb_SQLCommand.append("SELECT count(sEI.ExamItemID) ");
				sb_SQLCommand.append("FROM ExamItem sEI ");
				sb_SQLCommand.append("JOIN Subject sSJ ON sSJ.SubjectID = sEI.EI_SubjectID ");
				sb_SQLCommand.append("LEFT JOIN Unit sUN ON sUN.UnitID = sEI.EI_UnitID ");
				sb_SQLCommand.append("AND ISNULL(sUN.UN_DataStatus,-1) NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				sb_SQLCommand.append("LEFT JOIN Section sST ON sST.SectionID = sEI.EI_SectionID ");
				sb_SQLCommand.append("AND ISNULL(sST.ST_DataStatus,-1) NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				
				sb_SQLCommand.append("LEFT JOIN Objective sOJ ON sOJ.ObjectiveID = sEI.EI_ObjectiveID ");
				sb_SQLCommand.append( "AND ISNULL(sOJ.OJ_DataStatus,-1) NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
					
				sb_SQLCommand.append("LEFT JOIN BehaviorLevel sBL ON sBL.BehaviorLevelID = sEI.EI_BehaviorLevelID ");
				sb_SQLCommand.append("AND sBL.BL_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
					
				
				sb_SQLCommand.append("WHERE sSJ.SJ_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND sEI.EI_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
					
				sb_SQLCommand.append("AND sUN.UnitID =  UN.UnitID ");
				sb_SQLCommand.append("AND sST.SectionID = ST.SectionID ");
				sb_SQLCommand.append("AND sOJ.ObjectiveID = OJ.ObjectiveID ");
				sb_SQLCommand.append("AND sSJ.SubjectID = SJ.SubjectID ");
				sb_SQLCommand.append("AND (CASE WHEN EI.EI_BehaviorLevelID IS NULL THEN 10 ");
				sb_SQLCommand.append("WHEN EI.EI_BehaviorLevelID = sBL.BehaviorLevelID THEN 10 ");
				sb_SQLCommand.append("ELSE 20 END) = 10 ");
				sb_SQLCommand.append("AND ISNULL(EI.EI_BehaviorLevelID,-1) = ISNULL(sBL.BehaviorLevelID,-1) ");
				sb_SQLCommand.append("GROUP BY sOJ.ObjectiveID,sOJ.OJ_Order,sST.SectionID,sST.ST_Order,sUN.UnitID,sUN.UN_Order,sSJ.SubjectID ");
				sb_SQLCommand.append(") examItemNo ");
				// Find ExamItem
			
			sb_SQLCommand.append("FROM Objective OJ ");
			sb_SQLCommand.append("JOIN Section ST ON ST.SectionID = OJ.OJ_SectionID AND ISNULL(ST.ST_DataStatus,-1) NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
			
			sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID AND ISNULL(UN.UN_DataStatus,-1) NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
			
			sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID  ");
			sb_SQLCommand.append("JOIN ExamItem EI ON EI.EI_SubjectID = SJ.SubjectID  ");
	//			sb_SQLCommand.append("LEFT JOIN BehaviorLevel BL ON EI.EI_BehaviorLevelID = BL.BehaviorLevelID ");
		
			sb_SQLCommand.append("WHERE SJ.SJ_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
			
//					sb_SQLCommand.append("AND EI.EI_ObjectiveID = OJ.ObjectiveID ");
			
			sb_SQLCommand.append("AND OJ.OJ_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
			
			sb_SQLCommand.append("AND EI.EI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
			
	//			sb_SQLCommand.append("AND BL.BL_DataStatus NOT IN ( ");
	//			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
	//			sb_SQLCommand.append(", ");
	//			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
	//			sb_SQLCommand.append(") ");
			
			if(ao_subjectID != null){
				sb_SQLCommand.append("AND SJ.SubjectID IN (");
				int i = 0;
				for(Integer li_ExamYearID : ao_subjectID){
					if( i > 0){
						sb_SQLCommand.append(",");
					}
					sb_SQLCommand.append(li_ExamYearID);
					i++;
				}			
				sb_SQLCommand.append(") ");
				
			}
	//			sb_SQLCommand.append("OR EI.EI_BehaviorLevelID IS NULL ");
	//			sb_SQLCommand.append("AND EI.EI_SectionID = ST.SectionID  ");
	//			sb_SQLCommand.append("AND EI.EI_ObjectiveID = OJ.ObjectiveID ");	
			sb_SQLCommand.append("GROUP BY objectiveID,OJ.OJ_Order,OJ.OJ_Name,sectionID,ST.ST_Order,unitID,UN.UN_Order,subjectID,SJ.SJ_Code,SJ.SJ_SubjectPrintedName,EI.EI_BehaviorLevelID ");
//					sb_SQLCommand.append("ORDER BY subjectCode,unit,section,orderOfObjectiveInSection");//,behaviorLevelName" );
		sb_SQLCommand.append(") OBJSubject ");
		sb_SQLCommand.append("WHERE  ");
		sb_SQLCommand.append("(CASE WHEN examItemNo IS NOT NULL THEN 10 ");
		sb_SQLCommand.append("WHEN ObjectiveRow# = BehaviorLeveRow# THEN 10 ");
		sb_SQLCommand.append("ELSE 20 END) = 10  ");
		sb_SQLCommand.append("ORDER BY subjectCode,unit,section,orderOfObjectiveInSection");//,behaviorLevelName" );
		
		return sb_SQLCommand.toString();
	}	
	
//	จำนวนข้อสอบในตอน
	public Integer GetTotalExamItemNoInSectionBySectionID(Integer ai_unitID,Integer ai_sectionID) throws SQLException{
		String methodName = "GetTotalExamItemNoInSectionBySectionID";
		Integer li_examItemNoInSection = 0;
		if(ai_sectionID < 0){
			return 0;
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("ISNULL(COUNT(EI.ExamItemID),-1) totalExamItemNoInSection ");
		sb_SQLCommand.append("FROM ExamItem EI ");
		sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		
		// Samaporn @20190827
		sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NOT NULL ");
		sb_SQLCommand.append("AND EI.EI_DisableStatus IN (");
//		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_DISABLE.getValue());
//		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_ENABLE.getValue());
		sb_SQLCommand.append(") ");
		
		if(ai_sectionID != null){
			sb_SQLCommand.append("AND EI.EI_SectionID  = " + ai_sectionID + " ");
		}
		if(ai_unitID != null){
			sb_SQLCommand.append("AND EI.EI_UnitID  = " + ai_unitID + " ");
		}
		
//		sb_SQLCommand.append("AND EI.EI_BehaviorLevelID IS NOT NULL ");
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query :" + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			
			li_examItemNoInSection = lo_Result.getInt("totalExamItemNoInSection");
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "li_examItemNoInSection :" + li_examItemNoInSection);
		return li_examItemNoInSection;
	}
	
	public Integer GetTotalExamItemNoInUnitByUnitID(Integer ai_unitID) throws SQLException{
		String methodName = "GetTotalExamItemNoInUnitByUnitID";
		Integer li_examItemNoInUnit = 0;
		if(ai_unitID < 0){
			return 0;
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("ISNULL(COUNT(EI.ExamItemID),-1) totalExamItemNoInUnit ");
		sb_SQLCommand.append("FROM ExamItem EI ");
		sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		
		// Samaporn @20190827
		sb_SQLCommand.append("AND EI.EI_DisableStatus IN (");
//		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_DISABLE.getValue());
//		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_ENABLE.getValue());
		sb_SQLCommand.append(") ");
		
		if(ai_unitID != null){
			sb_SQLCommand.append("AND EI.EI_UnitID  = " + ai_unitID + " ");
		}

//		sb_SQLCommand.append("AND EI.EI_BehaviorLevelID IS NOT NULL ");
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query :" + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			
			li_examItemNoInUnit = lo_Result.getInt("totalExamItemNoInUnit");
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "li_examItemNoInUnit :" + li_examItemNoInUnit);
		return li_examItemNoInUnit;
	}
	

	public Integer GetTotalOfBehaviorLevelOnObjective(Integer ai_objectiveID,Integer ai_BehaviorLevelID) throws SQLException{
		String methodName = "GetTotalOfBehaviorLevelOnObjective";
		Integer li_totalOfBehavior = 0;
		if(ai_objectiveID < 0){
			return 0;
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append(" COUNT(*) totalOfBehavior ");
		sb_SQLCommand.append("FROM ( ");
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("EI.EI_ObjectiveID,EI.EI_BehaviorLevelID ");
		sb_SQLCommand.append("FROM BehaviorLevel BL ");
		sb_SQLCommand.append("JOIN ExamItem EI ON BL.BehaviorLevelID = EI.EI_BehaviorLevelID ");
		sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append("AND BL.BL_DataStatus  NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_objectiveID != null){
			sb_SQLCommand.append("AND EI.EI_ObjectiveID  = " + ai_objectiveID + " ");
		}
		if(ai_BehaviorLevelID != null){
			sb_SQLCommand.append("AND EI.EI_BehaviorLevelID  = " + ai_BehaviorLevelID + " ");
		}
		sb_SQLCommand.append("GROUP BY EI.EI_BehaviorLevelID,EI.EI_ObjectiveID ) AS TBL ");
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query :" + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			li_totalOfBehavior = lo_Result.getInt("totalOfBehavior");
		}
		
		return li_totalOfBehavior;
	}
	
	
	public Integer GetlastOrderOfObjectiveInSection(Integer ai_sectionID) throws SQLException{
		String methodName = "GetlastOrderOfObjectiveInSection";
		Integer li_lastOrderOfObjectiveInSection = 0;
		if(ai_sectionID < 0){
			return 0;
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("  TOP 1 ISNULL(OJ.OJ_Order,0) lastOrderOfObjectiveInSection ");
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("JOIN ExamItem EI ON OJ.ObjectiveID = EI.EI_ObjectiveID ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append("AND EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		
		// Samaporn @20190827
		sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NOT NULL ");
		sb_SQLCommand.append("AND EI.EI_DisableStatus IN (");
//		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_DISABLE.getValue());
//		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DISABLE_STATUS.STATUS_ENABLE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_sectionID != null){
			sb_SQLCommand.append("AND OJ.OJ_SectionID  = " + ai_sectionID + " ");
		}
		sb_SQLCommand.append("AND EI.EI_BehaviorLevelID IS NULL ");
		sb_SQLCommand.append("ORDER BY lastOrderOfObjectiveInSection DESC ");
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query :" + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			li_lastOrderOfObjectiveInSection = lo_Result.getInt("lastOrderOfObjectiveInSection");
		}
		
		return li_lastOrderOfObjectiveInSection;
	}
    
 // Samaporn @20191001
 	public void LoadReportAllObjectiveResultBySubjectIDNEW(List<Integer> ao_subjectID) throws SQLException{
 		String methodName = "LoadReportAllObjectiveResultBySubjectIDNEW";
 		String ls_SQLCommand = GenSQLFindAllObjectiveInSection(ao_subjectID);
 		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query : " + ls_SQLCommand);
 		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
 		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "##  ##");

 		int RowOrder = 0;
 		io_RPRL = new ArrayList<RP001Result>(0);

 		RP001Result lo_RPR;
 		if (lo_Result.next()) {
 			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query : lo_Result");
 			do {
 				RowOrder++;
 				lo_RPR = new RP001Result();
 				lo_RPR.setSubjectID(lo_Result.getInt("subjectID"));
 				String ls_subjectCodeName = lo_Result.getString("subjectCode");
 				String ls_subjectName = lo_Result.getString("subjectName");
 				if(ls_subjectCodeName == ""){
 					ls_subjectCodeName = ls_subjectName;
 				}else{
 					ls_subjectCodeName += " "+ls_subjectName;
 				}
 				lo_RPR.setSubjectCodeName(ls_subjectCodeName);
 				Integer li_unit = lo_Result.getInt("unit");
 				if(li_unit > 0){
 					lo_RPR.setUnit(Converter.Int2Str(li_unit));
 				}else{
 					lo_RPR.setUnit("");
 				}
 				Integer li_section = lo_Result.getInt("section");
 				if(li_section > 0){
 					lo_RPR.setSection(Converter.Int2Str(li_section));
 				}else{
 					lo_RPR.setSection("");
 				}
 				Integer li_orderOfObjectiveInSection = lo_Result.getInt("orderOfObjectiveInSection");
 				if(li_orderOfObjectiveInSection > 0){
 					lo_RPR.setOrderOfObjectiveInSection(Converter.Int2Str(li_orderOfObjectiveInSection));
 				}else{
 					lo_RPR.setOrderOfObjectiveInSection("");
 				}
 				lo_RPR.setExamItemNo(Converter.Int2Str(lo_Result.getInt("examItemNo")));
// 					lo_RPR.setBehaviorDefinition(lo_Result.getString("behaviorLevelName"));
 				lo_RPR.setObjective(lo_Result.getString("objective"));
 				lo_RPR.setUnitID(lo_Result.getInt("unitID"));
 				lo_RPR.setSectionID(lo_Result.getInt("sectionID"));
 				lo_RPR.setObjectiveID(lo_Result.getInt("objectiveID"));
 				lo_RPR.setBehaviorID(lo_Result.getInt("behaviorLevelID"));
 				io_RPRL.add(lo_RPR);
 			} while (lo_Result.next());
 		}
 		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Load End");
 	}
 	
 	
 // Samaporn @20191001
 	public List<RP001Result> CreateRP001AllObjectiveListResultNEW(List<Integer> ao_subjectID) throws SQLException{
 		RP001Result lo_RPR;
 		this.LoadReportAllObjectiveResultBySubjectIDNEW(ao_subjectID);
 		int i;
 		Integer li_totalExamItemNo = this.io_RPRL.size();
 		RP001Result lo_RPR_tmp = null;
 		HashMap<Integer,Integer> lo_TotalExamItemHash = new HashMap<Integer,Integer>(); 
 		HashMap<String,Integer> lo_TotalExamItemNoInSectionHash = new HashMap<String,Integer>(); 
 		HashMap<Integer,Integer> lo_TotalExamItemNoInUnitHash = new HashMap<Integer,Integer>(); 
 		HashMap<Integer,Integer> lo_LastOrderOfObjectiveInSectionHash = new HashMap<Integer,Integer>();
 		HashMap<Integer,String> lo_BehaviorDefinitionHash = new HashMap<Integer,String>();
 		HashMap<Integer,Integer> lo_TotalOfBehaviorHash = new HashMap<Integer,Integer>();
 		for (i=0;i<li_totalExamItemNo;i++){
 			lo_RPR = this.io_RPRL.get(i);
// 				lo_RPR_tmp = this.io_RPRL.get(i);
// 				if((i>=1)&&(i<(li_totalExamItemNo-1))){
// 					lo_RPR = this.io_RPRL.get(i+1);
// 				}else{
// 					lo_RPR = this.io_RPRL.get(i);
// 				}
 			
 			Integer li_unitID = lo_RPR.getUnitID();
 			Integer li_sectionID = lo_RPR.getSectionID();
 			Integer li_objectiveID = lo_RPR.getObjectiveID();
 			Integer li_subjectID = lo_RPR.getSubjectID();
 			Integer li_behaviorLevelID = lo_RPR.getBehaviorID();
 			if(lo_TotalExamItemHash.containsKey(li_subjectID)){
 				Integer li_TotalExamItem =lo_TotalExamItemHash.get(li_subjectID);
 				lo_RPR.setTotalExamItemNo(Converter.Int2Str(li_TotalExamItem));
 			}else{
 				Integer li_TotalExamItem = GetTotalExamItemBySubjectID(li_subjectID);
 				lo_TotalExamItemHash.put(li_subjectID, li_TotalExamItem);
 				lo_RPR.setTotalExamItemNo(Converter.Int2Str(li_TotalExamItem));				
 			}
// 				lo_RPR.setTotalExamItemNo(Converter.Int2Str(GetTotalExamItemBySubjectID(li_subjectID)));
 			String ls_UnitSectionkey = li_unitID+"-"+li_sectionID;
 			if(lo_TotalExamItemNoInSectionHash.containsKey(ls_UnitSectionkey)){
 				Integer li_TotalExamItemNoInSection =lo_TotalExamItemNoInSectionHash.get(ls_UnitSectionkey);
 				lo_RPR.setTotalExamItemNoInSection(Converter.Int2Str(li_TotalExamItemNoInSection));
 			}else{
 				Integer li_TotalExamItemNoInSection = this.GetTotalExamItemNoInSectionBySectionID(li_unitID,li_sectionID);
 				lo_TotalExamItemNoInSectionHash.put(ls_UnitSectionkey, li_TotalExamItemNoInSection);
 				lo_RPR.setTotalExamItemNoInSection(Converter.Int2Str(li_TotalExamItemNoInSection));				
 			}
// 				lo_RPR.setTotalExamItemNoInSection(Converter.Int2Str(this.GetTotalExamItemNoInSectionBySectionID(li_unitID,li_sectionID)));
 			if(lo_TotalExamItemNoInUnitHash.containsKey(li_unitID)){
 				Integer li_TotalExamItemNoInUnit =lo_TotalExamItemNoInUnitHash.get(li_unitID);
 				lo_RPR.setTotalExamItemNoInUnit(Converter.Int2Str(li_TotalExamItemNoInUnit));
 			}else{
 				Integer li_TotalExamItemNoInUnit = this.GetTotalExamItemNoInUnitByUnitID(li_unitID);
 				lo_TotalExamItemNoInUnitHash.put(li_unitID, li_TotalExamItemNoInUnit);
 				lo_RPR.setTotalExamItemNoInUnit(Converter.Int2Str(li_TotalExamItemNoInUnit));				
 			}
// 				lo_RPR.setTotalExamItemNoInUnit(Converter.Int2Str(this.GetTotalExamItemNoInUnitByUnitID(li_unitID)));
// 				lo_RPR.setLastOrderOfObjectiveInSection(Converter.Int2Str(this.GetlastOrderOfObjectiveInSection(li_sectionID)));
 			if(lo_LastOrderOfObjectiveInSectionHash.containsKey(li_sectionID)){
 				Integer li_LastOrderOfObjectiveInSection =lo_LastOrderOfObjectiveInSectionHash.get(li_sectionID);
 				lo_RPR.setLastOrderOfObjectiveInSection(Converter.Int2Str(li_LastOrderOfObjectiveInSection));
 			}else{
 				Integer li_LastOrderOfObjectiveInSection = this.GetlastOrderOfObjectiveInSection(li_sectionID);
 				lo_LastOrderOfObjectiveInSectionHash.put(li_sectionID, li_LastOrderOfObjectiveInSection);
 				lo_RPR.setLastOrderOfObjectiveInSection(Converter.Int2Str(li_LastOrderOfObjectiveInSection));				
 			}
// 				lo_RPR.setLastOrderOfObjectiveInSection(Converter.Int2Str(this.GetlastOrderOfObjectiveInSection(li_sectionID)));
// 				String ls_behaviorDefinition = GetBehaviorDefinitionByBehaviorID(li_behaviorLevelID);
 			if(li_behaviorLevelID > 0){
 				if(lo_BehaviorDefinitionHash.containsKey(li_behaviorLevelID)){
 					String li_BehaviorDefinition = lo_BehaviorDefinitionHash.get(li_behaviorLevelID);
 					lo_RPR.setBehaviorDefinition(li_BehaviorDefinition);
 				}else{
 					String li_BehaviorDefinition = this.GetBehaviorDefinitionByBehaviorID(li_behaviorLevelID);
 					lo_BehaviorDefinitionHash.put(li_behaviorLevelID, li_BehaviorDefinition);
 					lo_RPR.setBehaviorDefinition(li_BehaviorDefinition);				
 				}
// 					lo_RPR.setBehaviorDefinition(this.GetBehaviorDefinitionByBehaviorID(li_behaviorLevelID));
 			}else{
 				lo_RPR.setBehaviorDefinition("-");
 			}
// 				if(lo_RPR_tmp.getSectionID() == lo_RPR.getSectionID()){
// 					lo_RPR.setShowTotalExamItemNoInSection("0");
// 				}else{
// 					lo_RPR_tmp.setShowTotalExamItemNoInSection("1");
// 					lo_RPR_tmp = lo_RPR;
// 				}
// 				if(i==li_totalExamItemNo-1){
// 					lo_RPR.setShowTotalExamItemNoInSection("1");
// 				}
 			
// 				GetTotalOfBehaviorLevelOnObjective
 			if(lo_TotalOfBehaviorHash.containsKey(li_objectiveID)){
 				Integer li_TotalOfBehavior =lo_TotalOfBehaviorHash.get(li_objectiveID);
 				lo_RPR.setTotalOfBehavior(Converter.Int2Str(li_TotalOfBehavior));
 			}else{
 				Integer li_TotalOfBehavior = this.GetTotalOfBehaviorLevelOnObjective(li_objectiveID,li_behaviorLevelID);
 				lo_TotalOfBehaviorHash.put(li_objectiveID, li_TotalOfBehavior);
 				lo_RPR.setTotalOfBehavior(Converter.Int2Str(li_TotalOfBehavior));				
 			}
// 				lo_RPR.setTotalOfBehavior(Converter.Int2Str(this.GetTotalOfBehaviorLevelOnObjective(li_objectiveID)));
 		}
 		
 		return io_RPRL;
 	
 	}
    
    public static void main(String[] args) throws ClassNotFoundException, SQLException {
		// TODO Auto-generated method stub
		RP001Generator n = new RP001Generator();
		List<Integer> lo_subjectID = new ArrayList();
		lo_subjectID.add(46);
		try {
			List<RP001Result> result = n.CreateRP001AllObjectiveListResultNEW(lo_subjectID);
			
			System.out.println("Size : " + result.size());
			for (int b = 0; b < result.size(); b++) {
				System.out.println("-----------------------------");
				System.out.println("Row --->: " + (b + 1));
				System.out.println("-----------------------------");
				System.out.print(result.get(b));
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

}