package esi.ew.report.common;

import java.sql.SQLException;
import java.util.List;

import com.plw.util.DataNotFoundException;


public class CommonLog {
	private static boolean cb_LogMode = PolicyController.CommonLog;
	private static boolean cb_SQLCommandLog = PolicyController.SQLCommandLog;
	private static boolean cb_SystemCommonLog = PolicyController.SystemCommonLog;
	private static boolean cb_ExceptionLog = PolicyController.ExceptionLog;
	private static boolean cb_DAOExceptionLog = PolicyController.DAOExceptionLog;
	public static void Print(LOG_LEVEL LL, String AppName, String ModuleName, String Message) {
		//System.out.println("CommonLog [START]");
		/*try {
			ESIPrintStream.DisPatch();
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		}*/
		if (cb_LogMode) {
			if (LL == LOG_LEVEL.INFO_LEVEL) {
				System.out.println("[INFO]-[" + AppName + ":" + ModuleName + "] -> " + Message);
				
			} else if (LL == LOG_LEVEL.WARN_LEVEL) {
				System.out.println("[WARN]-[" + AppName + ":" + ModuleName + "] -> " + Message);
			} else if (LL == LOG_LEVEL.ERROR_LEVEL) {
				System.out.println("[ERROR]-[" + AppName + ":" + ModuleName + "] -> " + Message);
			} else { 
				System.out.println("[INFO]-[" + AppName + ":" + ModuleName + "] -> " + Message);
			}
				
		}
		if(cb_SQLCommandLog){
			if (LL == LOG_LEVEL.DEBUG_LEVEL) {
				System.out.println("[SQLCOMMAND]-[" + AppName + ":" + ModuleName + "] -> " + Message);
			}
		}
		if(cb_SystemCommonLog){
			if (LL == LOG_LEVEL.SQL_COMMAND_LEVEL) {
				System.out.println("[SQLCOMMAND]-[" + AppName + ":" + ModuleName + "] -> " + Message);
			}
		}
	}
	
	public static void PrintStackTrace(Exception ex) {
		if(ex instanceof SQLException) {
			if (cb_SQLCommandLog) {
				ex.printStackTrace();		
			}else {
				if (cb_LogMode) {
					System.out.println("[SQL EXCEPTION] -> " + ex.getMessage());
				}
			}
		}if(ex instanceof DataNotFoundException) {
			if (cb_DAOExceptionLog) {
				ex.printStackTrace();		
			}else {
				if (cb_LogMode) {
					System.out.println("[DAO EXCEPTION] -> " + ex.getMessage());
				}
			}
		}else {
			if (cb_ExceptionLog) {
				ex.printStackTrace();		
			}else {
				if (cb_LogMode) {
					System.out.println("[EXCEPTION] -> " + ex.getMessage());
				}
			}
		}
		
	}
	public static void Print(Object Message) {
		if (cb_LogMode) {
			if(Message instanceof List) {
				List<?> l_object = (List<?>) Message;
				for(Object o : l_object) {
					System.out.println(o.getClass().getName()+": {"+ o +" }");
				}
			}else if(Message instanceof String){
				System.out.println(Message);
			}else {
				if(Message != null) {
					System.out.println(Message.getClass().getName()+": {"+ Message.toString()+" }");
				}else {
					System.out.println(Message);
				}
			}
		}
	}
	
	public static void main(String []a) {
		CommonLog.Print("test");
		CommonLog.PrintStackTrace(new Exception("Exception test"));
	}
}
