package esi.ew.report.service;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.awt.Font;
import java.awt.FontFormatException;
import java.awt.GraphicsEnvironment;

import esi.ew.report.RP001.RP001Generator;
import esi.ew.report.RP001.RP001Result;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import net.sf.jasperreports.engine.JRDataSource;
import net.sf.jasperreports.engine.JRParameter;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

/**
 * @author Samaporn Ch
 */

public class RP001Service {

	private static String ls_className = "RP001Service";
	private static String jrxmlName = "\\RP001.jrxml" ;
	private static String jasperName = "\\RP001.jasper" ;
	
	private static int li_result = 0;
	
	private static JRDataSource createReportDataSource(List<Integer> ao_subjectID){
		String methodName = "createReportDataSource";
		JRBeanCollectionDataSource dataSource;
	
		try {
			RP001Generator io_RP001Generator = new RP001Generator();
			List<RP001Result> lo_RP001Result = io_RP001Generator.CreateRP001AllObjectiveListResultNEW(ao_subjectID);
			li_result = lo_RP001Result.size();
			for (int b = 0; b < lo_RP001Result.size(); b++) {
				try {
					CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "subjectID" + ao_subjectID);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
//				System.out.println("Row --->: " + (b + 1));
//				System.out.println("-----------------------------");
//				System.out.print(lo_RP001Result.get(b));
			}
			
			Collection reportRows = lo_RP001Result;
			dataSource = new JRBeanCollectionDataSource(reportRows);
			return dataSource;
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	public static byte [] GetPDFContent(String as_reportTemplatePath,List<Integer> ao_subjectID)throws Exception{
		 String methodName = "GetPDFContent";
		 String ls_path = "D:\\My Development Projects\\STOU-EW-II Workspace\\EXAM-WAREHOUSE-REPORT-CORE\\jasperReport\\stou-ew";
		 byte [] lb_result = null;
		 if(as_reportTemplatePath != null){
			 ls_path = as_reportTemplatePath;
		 }
		
		JRDataSource dataSource = createReportDataSource(ao_subjectID);
		if(li_result!=0){
			
			java.io.ByteArrayOutputStream output = new java.io.ByteArrayOutputStream();
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "JESPER FILE PATH >>> "+ls_path+jasperName);
			java.io.InputStream reportStream = new java.io.FileInputStream(new File(ls_path+jasperName));
			
			Map Parameters = new HashMap();
			Parameters.put(JRParameter.REPORT_LOCALE, new Locale("en", "EN")); 
			Parameters.put("reportsDirPath",  ls_path);
			Parameters.put("SUBREPORT_DIR",  ls_path);


			JasperRunManager.runReportToPdfStream(reportStream,output, Parameters, dataSource);
			lb_result = output.toByteArray();
//				FO.flush();
			output.close();
		}
		
		return lb_result;
	}
	
	// For Test
	public static void main(String[] args) {
		try {
			// GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
			// Font sarabun = Font.createFont(Font.TRUETYPE_FONT, new File("src/main/resources/fonts/THSarabunNew.ttf"));
			// ge.registerFont(sarabun);
			List<Integer> ai_subjectID = new ArrayList();
			ai_subjectID.add(46);
			String[] fonts = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
			for (String font : fonts) {
				System.out.println(font);
			}
			RP001Service n = new RP001Service();
			byte [] result_GetContent = n.GetPDFContent(null, ai_subjectID);
			java.io.OutputStream FO = new java.io.FileOutputStream("RP001_ID69.pdf"); 
			FO.write(result_GetContent);
			FO.flush();
			FO.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		

	}
	


}
